## ignition-physics 5.1.0+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-physics5 VERSION 5.1.0)

#============================================================================
# Find ignition-cmake
#============================================================================
find_package(ignition-cmake2 2.8.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project(VERSION_SUFFIX)

#============================================================================
# Set project-specific options
#============================================================================

option(ENABLE_PROFILER "Enable Ignition Profiler" FALSE)

if(ENABLE_PROFILER)
  add_definitions("-DIGN_PROFILER_ENABLE=1")
else()
  add_definitions("-DIGN_PROFILER_ENABLE=0")
endif()

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find ignition-common
ign_find_package(ignition-common4
  COMPONENTS graphics profiler
  REQUIRED_BY heightmap mesh dartsim tpe tpelib bullet)
set(IGN_COMMON_VER ${ignition-common4_VERSION_MAJOR})

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED COMPONENTS eigen3)
set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-plugin
ign_find_package(ignition-plugin1 REQUIRED COMPONENTS all VERSION 1.1)
set(IGN_PLUGIN_VER ${ignition-plugin1_VERSION_MAJOR})

#--------------------------------------
# Find ignition-utils
ign_find_package(ignition-utils1 REQUIRED COMPONENTS cli)
set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})

#--------------------------------------
# Find Eigen
ign_find_package(EIGEN3 REQUIRED)

#--------------------------------------
# Find SDFormat for the SDF features
ign_find_package(sdformat12
  REQUIRED_BY sdf dartsim tpe bullet)

#--------------------------------------
# Find dartsim for the dartsim plugin wrapper
ign_find_package(DART
  COMPONENTS
    collision-bullet
    collision-ode
    utils
    utils-urdf
  EXTRA_ARGS CONFIG
  VERSION 6.9
  REQUIRED_BY dartsim
  PKGCONFIG dart
  PKGCONFIG_VER_COMPARISON >=)

#--------------------------------------
# Find bullet for the bullet plugin wrapper
ign_find_package(IgnBullet
  VERSION 2.87
  REQUIRED_BY bullet
  PKGCONFIG bullet
  PKGCONFIG_VER_COMPARISON >=)

message(STATUS "-------------------------------------------\n")

set(IGNITION_PHYSICS_RESOURCE_DIR "${CMAKE_SOURCE_DIR}/resources")

# Plugin install dirs
set(IGNITION_PHYSICS_ENGINE_INSTALL_DIR
  ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/engine-plugins
)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS sdf heightmap mesh dartsim tpe bullet)


#============================================================================
# Create package information
#============================================================================
ign_create_packages()


#============================================================================
# Create documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  TAGFILES
    "${IGNITION-COMMON_DOXYGEN_TAGFILE} = ${IGNITION-COMMON_API_URL}"
    "${IGNITION-PLUGIN_DOXYGEN_TAGFILE} = ${IGNITION-PLUGIN_API_URL}"
    "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
  )

file(COPY ${CMAKE_SOURCE_DIR}/tutorials/img/ DESTINATION ${CMAKE_BINARY_DIR}/doxygen/html/img/)

=== bullet/CMakeLists.txt ===
# This component expresses custom features of the bullet plugin, which can
# expose native bullet data types.
ign_add_component(bullet INTERFACE
  DEPENDS_ON_COMPONENTS sdf mesh
  GET_TARGET_NAME features)

link_directories(${BULLET_LIBRARY_DIRS})
target_link_libraries(${features} INTERFACE IgnBullet::IgnBullet)

ign_get_libsources_and_unittests(sources test_sources)

# TODO(MXG): Think about an ign_add_plugin(~) macro for ign-cmake
set(engine_name bullet-plugin)
ign_add_component(${engine_name}
  SOURCES ${sources}
  DEPENDS_ON_COMPONENTS bullet
  GET_TARGET_NAME bullet_plugin)

target_link_libraries(${bullet_plugin}
  PUBLIC
    ${features}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-math${IGN_MATH_VER}::eigen3)

# Note that plugins are currently being installed in 2 places: /lib and the engine-plugins dir
install(TARGETS ${bullet_plugin} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# The library created by `ign_add_component` includes the ign-physics version
# (i.e. libignition-physics1-name-plugin.so), but for portability,
# we also install an unversioned symlink into the same versioned folder.
set(versioned ${CMAKE_SHARED_LIBRARY_PREFIX}${bullet_plugin}${CMAKE_SHARED_LIBRARY_SUFFIX})
set(unversioned ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME_NO_VERSION_LOWER}-${engine_name}${CMAKE_SHARED_LIBRARY_SUFFIX})
if (WIN32)
  # disable MSVC inherit via dominance warning
  target_compile_options(${bullet_plugin} PUBLIC "/wd4250")
  INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${versioned}
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${unversioned})")
else()
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
  INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})
endif()
EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# Testing
ign_build_tests(
  TYPE UNIT_bullet
  SOURCES ${test_sources}
  LIB_DEPS
    ${features}
    ignition-plugin${IGN_PLUGIN_VER}::loader
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
  TEST_LIST tests)

foreach(test ${tests})

  target_compile_definitions(${test} PRIVATE
    "bullet_plugin_LIB=\"$<TARGET_FILE:${bullet_plugin}>\""
    "TEST_WORLD_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/worlds/\""
    "IGNITION_PHYSICS_RESOURCE_DIR=\"${IGNITION_PHYSICS_RESOURCE_DIR}\"")

endforeach()

if(TARGET UNIT_FindFeatures_TEST)

  target_compile_definitions(UNIT_FindFeatures_TEST PRIVATE
    "bullet_plugin_LIB=\"$<TARGET_FILE:${bullet_plugin}>\"")

endif()

=== dartsim/CMakeLists.txt ===
# This component expresses custom features of the dartsim plugin, which can
# expose native dartsim data types.
ign_add_component(dartsim INTERFACE
  DEPENDS_ON_COMPONENTS sdf heightmap mesh
  GET_TARGET_NAME features)

target_link_libraries(${features} INTERFACE ${DART_LIBRARIES})
target_include_directories(${features} SYSTEM INTERFACE ${DART_INCLUDE_DIRS})
if (MSVC)
  # needed by DART, see https://github.com/dartsim/dart/issues/753
  target_compile_options(${features} INTERFACE "/permissive-")
endif()

install(
  DIRECTORY include/
  DESTINATION "${IGN_INCLUDE_INSTALL_DIR_FULL}")

ign_get_libsources_and_unittests(sources test_sources)

# TODO(MXG): Think about an ign_add_plugin(~) macro for ign-cmake
set(engine_name dartsim-plugin)
ign_add_component(${engine_name}
  SOURCES ${sources}
  DEPENDS_ON_COMPONENTS dartsim
  GET_TARGET_NAME dartsim_plugin)

target_link_libraries(${dartsim_plugin}
  PUBLIC
    ${features}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-heightmap
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-math${IGN_MATH_VER}::eigen3
  PRIVATE
    # We need to link this, even when the profiler isn't used to get headers.
    ignition-common${IGN_COMMON_VER}::profiler
)

# The ignition fork of DART contains additional code that allows customizing 
# contact constraints. We check for the presence of "ContactSurface.hpp", which 
# was added to enable these customizations, to detect if the feature is 
# available.
include(CheckIncludeFileCXX)
if (MSVC)
  set(CMAKE_REQUIRED_FLAGS "/std:c++14")
else()
  set(CMAKE_REQUIRED_FLAGS "-std=c++14")
endif()
set(CMAKE_REQUIRED_INCLUDES "${DART_INCLUDE_DIRS};${EIGEN3_INCLUDE_DIRS}")
set(CMAKE_REQUIRED_QUIET false)

CHECK_INCLUDE_FILE_CXX(dart/constraint/ContactSurface.hpp DART_HAS_CONTACT_SURFACE_HEADER)
if (DART_HAS_CONTACT_SURFACE_HEADER)
  target_compile_definitions(${dartsim_plugin} PRIVATE DART_HAS_CONTACT_SURFACE)
else()
  message(STATUS "The version of DART does not support Contact constraint customizations.")
endif()

# Note that plugins are currently being installed in 2 places: /lib and the engine-plugins dir
install(TARGETS ${dartsim_plugin} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# The library created by `ign_add_component` includes the ign-physics version
# (i.e. libignition-physics1-name-plugin.so), but for portability,
# we also install an unversioned symlink into the same versioned folder.
set(versioned ${CMAKE_SHARED_LIBRARY_PREFIX}${dartsim_plugin}${CMAKE_SHARED_LIBRARY_SUFFIX})
set(unversioned ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME_NO_VERSION_LOWER}-${engine_name}${CMAKE_SHARED_LIBRARY_SUFFIX})
if (WIN32)
  # disable MSVC inherit via dominance warning
  target_compile_options(${dartsim_plugin} PUBLIC "/wd4250")
  INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${versioned}
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${unversioned})")
else()
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
  INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})
endif()

# Testing
ign_build_tests(
  TYPE UNIT
  SOURCES ${test_sources}
  LIB_DEPS
    ${features}
    ignition-plugin${IGN_PLUGIN_VER}::loader
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-heightmap
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
  TEST_LIST tests)

foreach(test ${tests})

  target_compile_definitions(${test} PRIVATE
    "dartsim_plugin_LIB=\"$<TARGET_FILE:${dartsim_plugin}>\""
    "TEST_WORLD_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/worlds/\""
    "IGNITION_PHYSICS_RESOURCE_DIR=\"${IGNITION_PHYSICS_RESOURCE_DIR}\"")

  if (DART_HAS_CONTACT_SURFACE_HEADER)
    target_compile_definitions(${test} PRIVATE DART_HAS_CONTACT_SURFACE)
  endif()

  # Helps when we want to build a single test after making changes to dartsim_plugin
  add_dependencies(${test} ${dartsim_plugin})
endforeach()

foreach(test UNIT_FindFeatures_TEST UNIT_RequestFeatures_TEST)
  if(TARGET ${test})
    target_compile_definitions(${test} PRIVATE
      "dartsim_plugin_LIB=\"$<TARGET_FILE:${dartsim_plugin}>\"")
  endif()
endforeach()

=== include/CMakeLists.txt ===
add_subdirectory(ignition/physics)

=== mesh/CMakeLists.txt ===

ign_add_component(mesh INTERFACE
  GET_TARGET_NAME mesh)

target_link_libraries(${mesh}
  INTERFACE
    ignition-common${IGN_COMMON_VER}::graphics)

install(
  DIRECTORY include/
  DESTINATION "${IGN_INCLUDE_INSTALL_DIR_FULL}")

=== sdf/CMakeLists.txt ===

ign_add_component(sdf INTERFACE
  GET_TARGET_NAME sdf)

target_link_libraries(${sdf} INTERFACE ${SDFormat_LIBRARIES})

install(
  DIRECTORY include/
  DESTINATION "${IGN_INCLUDE_INSTALL_DIR_FULL}")

=== src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)

ign_create_core_library(SOURCES ${sources} CXX_STANDARD 17)

target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ${ignition-math${IGN_MATH_VER}_LIBRARIES}
    ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
    ignition-plugin${IGN_PLUGIN_VER}::register
    Eigen3::Eigen)

ign_build_tests(
  TYPE UNIT
  SOURCES ${gtest_sources})

if(TARGET UNIT_FindFeatures_TEST)
  target_link_libraries(UNIT_FindFeatures_TEST
    ignition-plugin${IGN_PLUGIN_VER}::loader)
endif()

=== test/CMakeLists.txt ===
if (NOT BUILD_TESTING)
  return()
endif()

include_directories (
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
  ${CMAKE_BINARY_DIR}/include
)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
set_property(TARGET gtest_main PROPERTY CXX_STANDARD ${c++standard})
set_property(TARGET gtest PROPERTY CXX_STANDARD ${c++standard})
set(GTEST_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest.a")
set(GTEST_MAIN_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest_main.a")

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
# This gives us access to src/utils headers
include_directories(${PROJECT_SOURCE_DIR}/src ${GTEST_INCLUDE_DIRS})

#============================================================================
# Do a fake install of ign-physics in order to test the examples.
#============================================================================
set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")

file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})

include(ExternalProject)
ExternalProject_Add(
  FAKE_INSTALL

  SOURCE_DIR "${CMAKE_SOURCE_DIR}"
  EXCLUDE_FROM_ALL 1
  LOG_CONFIGURE 1
  LOG_BUILD 1
  LOG_INSTALL 1
  CMAKE_ARGS
    "-DBUILD_TESTING=OFF"
    "-DCMAKE_INSTALL_PREFIX=${FAKE_INSTALL_PREFIX}"
)

add_subdirectory(benchmark)
add_subdirectory(plugins)
add_subdirectory(integration)
add_subdirectory(performance)
add_subdirectory(regression)
add_subdirectory(static_assert)

=== tpe/CMakeLists.txt ===
add_subdirectory(lib)
add_subdirectory(plugin)

=== examples/hello_world_loader/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 5)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_executable(hello_world_loader hello_world_loader.cc)
target_link_libraries(hello_world_loader
  ignition-plugin${IGN_PLUGIN_VER}::loader
  ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

=== examples/hello_world_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 5)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_library(HelloWorldPlugin SHARED HelloWorldPlugin.cc)
target_link_libraries(HelloWorldPlugin
  PRIVATE
    ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

=== examples/simple_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 5)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_library(SimplePlugin SHARED plugin.cc EntityManagementFeatures.cc)
target_link_libraries(SimplePlugin
  PRIVATE
    ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

add_executable(PluginTest EntityManagementFeatures_TEST.cc)
target_link_libraries(PluginTest
  ignition-plugin${IGN_PLUGIN_VER}::loader
  ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

target_compile_definitions(PluginTest PRIVATE
  "simple_plugin_LIB=\"$<TARGET_FILE:SimplePlugin>\"")

=== debian/changelog ===
ignition-physics (5.1.0+ds1-4ubuntu1) jammy; urgency=medium

    * Filter out flto=auto -ffat-lto-objects to fix amd64 build
      LP: #1965064
    * Extend ppc64 patch to relax test expectation (fix ppc64 build)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 16 Mar 2022 19:26:31 +0000

ignition-physics (5.1.0+ds1-4) unstable; urgency=medium

  * Include more debug information in FAKE patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 14 Feb 2022 22:29:14 +0000

ignition-physics (5.1.0+ds1-3) experimental; urgency=medium

  * Limit compilation threads in FAKE test to help ARM builds
  * Add patch to fix ppc64 test failures

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 14 Feb 2022 16:43:23 +0000

ignition-physics (5.1.0+ds1-2) experimental; urgency=medium

  * Fix package names for ignition-physics dev file
  * Use no-parallel in the whole build
    Build consumes huge amounts of RAM and the testsuite can not run in
    parallel.

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 14 Feb 2022 12:11:10 +0000

ignition-physics (5.1.0+ds1-1) experimental; urgency=medium

  * New upstream version 5.1.0+ds
    (Closes: #1001706)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 18 Dec 2021 20:25:28 +0000

=== debian/control ===
Source: ignition-physics
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper-compat (= 13),
               doxygen,
               libbullet-dev,
               libdart-dev (>= 6.12.1+dfsg4),
               libdart-collision-bullet-dev (>= 6.12.1+dfsg4),
               libdart-collision-ode-dev (>= 6.12.1+dfsg4),
               libdart-external-convhull-3d-dev (>= 6.12.1+dfsg4),
               libdart-external-ikfast-dev (>= 6.12.1+dfsg4),
               libdart-external-odelcpsolver-dev (>= 6.12.1+dfsg4),
               libdart-utils-dev (>= 6.12.1+dfsg4),
               libdart-utils-urdf-dev (>= 6.12.1+dfsg4),
               libignition-cmake-dev (>= 2.8.0),
               libignition-common-dev (>= 4.0.0),
               libignition-math-dev (>= 6.0.0),
               libignition-plugin-dev (>= 1.1.0),
               libignition-utils-dev,
               libeigen3-dev,
               libgtest-dev,
               libsdformat-dev (>= 12.0.0)
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/ignition-physics
Vcs-Git: https://salsa.debian.org/science-team/ignition-physics.git
Rules-Requires-Root: no
Homepage: http://ignitionrobotics.org/libs/physics

Package: libignition-physics-core-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake-dev (>= 2.1.0),
         libignition-math-dev (>= 6.0.0),
         libignition-plugin-dev (>= 1.1.0),
         libignition-physics5-5 (= ${binary:Version}),
         libignition-utils-dev,
         ${misc:Depends}
Suggests: ignition-tools
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Core Development files
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Core component, development files

Package: libignition-physics-sdf-dev
Architecture: any
Section: libdevel
Depends: libignition-physics-core-dev,
         libignition-cmake-dev (>= 2.1.0),
         libsdformat-dev (>= 12.0.0),
         libignition-physics5-5 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - SDF Dev files
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 SDF component, development files

Package: libignition-physics-mesh-dev
Architecture: any
Section: libdevel
Depends: libignition-physics-core-dev,
         libignition-cmake-dev (>= 2.1.0),
         libignition-common-dev (>= 4.0.0),
         libignition-physics5-5 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Mesh Dev files
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Mesh component, development files

Package: libignition-physics-heightmap-dev
Architecture: any
Section: libdevel
Depends: libignition-physics-core-dev (= ${binary:Version}),
         libignition-cmake-dev (>= 2.1.0),
         libignition-common-graphics-dev,
         libignition-physics5-5 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Heightmap Dev files
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Heightmap component, development files

Package: libignition-physics5-5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Shared library
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Main shared library

Package: libignition-physics5-dartsim-plugin5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Dartsim library
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 DARTSim component shared library

Package: libignition-physics5-bullet-plugin5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Bullet library
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Bullet component shared library

Package: libignition-physics-tpe-dev
Architecture: any
Section: libdevel
Depends: libignition-physics-core-dev,
         libignition-physics-sdf-dev,
         libignition-physics-mesh-dev,
         libignition-cmake-dev (>= 2.1.0),
         libignition-math-dev (>= 6.0.0),
         libignition-plugin-dev (>= 1.1.0),
         libsdformat-dev (>= 12.0.0),
         libignition-physics5-tpe-plugin5 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE Development files
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 TPE plugin component, development files

Package: libignition-physics5-tpe-plugin5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library plugin
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 TPE and TPElib plugin component shared library

Package: libignition-physics5-tpelib5
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 TPE library component shared library

Package: libignition-physics-dev
Architecture: any
Section: libdevel
Depends: libignition-physics-core-dev,
         libignition-physics-mesh-dev,
         libignition-physics-sdf-dev,
         libignition-physics-tpe-dev,
         libignition-physics5-dartsim-plugin5 (= ${binary:Version}),
# Bullet component dependencies
         libbullet-dev,
# DART component dependencies:
         libignition-common-dev (>= 4.0.0),
         libignition-math-dev (>= 6.0.0),
         libignition-plugin-dev (>= 1.1.0),
         libdart-dev (>= 6.12.1+dfsg4),
         libdart-external-convhull-3d-dev (>= 6.12.1+dfsg4),
         libdart-collision-ode-dev (>= 6.12.1+dfsg4),
         libdart-utils-urdf-dev (>= 6.12.1+dfsg4),
         libdart-utils-dev (>= 6.12.1+dfsg4),
         libdart-external-odelcpsolver-dev (>= 6.12.1+dfsg4),
         libdart-external-ikfast-dev (>= 6.12.1+dfsg4),
         libdart-collision-bullet-dev (>= 6.12.1+dfsg4),
         libsdformat-dev (>= 12.0.0),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Metapackage
 Ignition Physics is a component in the ignition framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Metapackage, all development files include DARTSim and Bullet component

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# segfault. See https://github.com/ignitionrobotics/ign-physics/issues/330
CXXFLAGS:=$(filter-out -flto=auto -ffat-lto-objects -flto=auto -ffat-lto-objects,$(CXXFLAGS))
LDFLAGS:=$(filter-out -flto=auto -ffat-lto-objects -flto=auto -ffat-lto-objects,$(LDFLAGS))

# The build consumes huge amounts of RAM, can not build it in mulithread
# test suite can not be run in parallel too.
%:
	dh $@ --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DENABLE_PROFILER=True

# Test suite cannot run in parallel
# arm64 problems https://github.com/ignitionrobotics/ign-physics/issues/70
override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),arm64)
	true
else
	dh_auto_test
endif

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
    dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repacksuffix=+ds \
    https://github.com/ignitionrobotics/ign-physics/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz
